package com.mortals.xhx.module.picture.web;

import com.alibaba.fastjson.JSONObject;
import com.mortals.framework.annotation.UnAuth;
import com.mortals.framework.exception.AppException;
import com.mortals.framework.model.Context;
import com.mortals.framework.model.PageInfo;
import com.mortals.framework.model.Result;
import com.mortals.framework.web.BaseCRUDJsonBodyMappingController;
import com.mortals.xhx.base.system.param.model.ParamEntity;
import com.mortals.xhx.base.system.param.service.ParamService;
import com.mortals.xhx.base.system.param.web.ParamForm;
import com.mortals.xhx.module.picture.model.vo.PictureGroupCountVo;
import com.mortals.xhx.module.picture.service.PictureMaterialService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.security.core.parameters.P;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

@RestController
@RequestMapping("material/group")
public class PictureGroupController extends BaseCRUDJsonBodyMappingController<ParamService, ParamEntity,Long> {

    @Autowired
    private PictureMaterialService pictureMaterialService;

    public PictureGroupController() {
        super.setModuleDesc("素材分组");
    }

    @Override
    protected void saveBefore(ParamEntity entity, Map<String, Object> model, Context context) throws AppException {
        entity.setName("素材分组");
        entity.setFirstOrganize("PictureMaterial");
        entity.setSecondOrganize("pictureGroupId");
    }

    @Override
    public String list(@RequestBody ParamEntity entity) {
        Map<String, Object> model = new HashMap();
        JSONObject ret = new JSONObject();
        Context context = this.getContext();
        String busiDesc = "查询" + this.getModuleDesc();

        int code=1;
        try {
            ParamEntity query = new ParamEntity();
            query.setFirstOrganize("PictureMaterial");
            query.setSecondOrganize("pictureGroupId");

            List<PictureGroupCountVo> list = pictureMaterialService.selectPictureGroupCount();

            model.put("data", list);
            this.recordSysLog(this.request, busiDesc + " 【成功】");
        } catch (Exception var9) {
            code = -1;
            this.doException(this.request, busiDesc, model, var9);
        }
        ret.put("code", code);
        ret.put("msg", model.remove("message_info"));
        ret.put("data", model);
        return ret.toJSONString();
    }
}
